poss(receivesms(_, _), Z) :- holds(callcenterup, Z).
poss(receivecall(_, _), Z) :- holds(callcenterup, Z).
poss(retrievelocation(USER, REQUEST, _), Z) :- holds(hasinput(REQUEST), Z), holds(gpsactive(USER), Z).
poss(retrievediagnostics(VEHICLE, REQUEST, _), Z) :- holds(hasinput(REQUEST), Z), holds(systemactive(VEHICLE), Z).

poss(findmech(STATUS, LOCATION, _), Z) :- holds(hasinput(STATUS), Z), holds(hasinput(LOCATION), Z), holds(received(LOCATION, USER), Z), holds(received(STATUS, VEHICLE), Z), not_holds(solved(STATUS, LOCATION), Z).
poss(receivepay(PAYFORM, _), Z) :- holds(hasinput(PAYFORM), Z), holds(solved(STATUS, LOCATION), Z).
poss(ereport(INVOICE, REPORT), Z) :- holds(hasinput(INVOICE), Z), holds(paycompleted(PAYFORM), Z), holds(generated(MECHLOG), Z), not_holds(emailed(REPORT), Z).
poss(mreport(INVOICE, REPORT), Z) :- holds(hasinput(INVOICE), Z), holds(paycompleted(PAYFORM), Z), holds(generated(MECHLOG), Z), not_holds(delivered(REPORT), Z).


state_update(Z, receivesms(SMS, REQUEST), Z_PR) :- update(Z, [hasoutput(REQUEST), received(REQUEST, SMS)], [], Z_PR).
state_update(Z, receivecall(CALL, REQUEST), Z_PR) :- \+ state_update(Z, receivesms(SMS, REQUEST), Z_PR), update(Z, [hasoutput(REQUEST), received(REQUEST, CALL)], [], Z_PR).
state_update(Z, retrievelocation(USER, REQUEST, LOCATION), Z_PR) :- update(Z, [hasoutput(LOCATION), received(LOCATION, USER)], [hasinput(REQUEST)], Z_PR).
state_update(Z, retrievediagnostics(VEHICLE, REQUEST, STATUS), Z_PR) :- ramify(Z, [hasoutput(STATUS), received(STATUS, VEHICLE)], [hasinput(REQUEST)], Z_PR).

state_update(Z, findmech(STATUS, LOCATION, PAYFORM), Z_PR) :- update(Z, [hasoutput(PAYFORM), solved(STATUS, LOCATION)], [hasinput(STATUS), hasinput(LOCATION)], Z_PR).
state_update(Z, receivepay(PAYFORM, INVOICE), Z_PR) :- update(Z, [hasoutput(INVOICE), paycompleted(PAYFORM)], [hasinput(PAYFORM)], Z_PR).
state_update(Z, ereport(INVOICE, REPORT), Z_PR) :- update(Z, [hasoutput(REPORT), emailed(REPORT)], [hasinput(INVOICE)], Z_PR).
state_update(Z, mreport(INVOICE, REPORT), Z_PR) :- update(Z, [hasoutput(REPORT), delivered(REPORT)], [hasinput(INVOICE)], Z_PR).

causes(Z, P, N, [generated(MECHLOG)|Z], [generated(MECHLOG)|P], N) :- P = [hasoutput(STATUS), received(STATUS, VEHICLE)], N = [hasinput(REQUEST)].

%assist_plan(Z, [], Z) :- holds(solved(STATUS, LOCATION), Z), holds(paycompleted(PAYFORM), Z), holds(emailed(REPORT), Z).

%assist_plan(Z_IN, [A|P], Z_IN_PR) :- poss(A, Z_IN), state_update(Z_IN, A, Z_1), assist_plan(Z_1, P, Z_IN_PR).
assist_plan(Z, [A|P], Z_PR) :- A_1 = receivesms(_, _), A_2 = receivecall(_, _), A = xor(A_1, A_2), poss_xor(A_1, A_2, Z), state_update_xor(Z, A_1,A_2, Z_1), assist_plan1(Z_1, P, Z_PR).
assist_plan1(Z, [A|P], Z_PR) :- A_1 = retrievelocation(_, _, _), A_2 = retrievediagnostics(_, _, _), A = and(A_1, A_2), poss_and(A_1, A_2, Z), state_update_and(Z, A_1,A_2, Z_1), assist_plan2(Z_1, P, Z_PR).
assist_plan2(Z, [A|P], Z_PR) :- A = findmech(_, _, _), poss(A, Z), state_update(Z, A, Z_1), assist_plan3(Z_1, P, Z_PR).
assist_plan3(Z, [A|P], Z_PR) :- A = receivepay(_, _), poss(A, Z), state_update(Z, A, Z_1), assist_plan4(Z_1, P, Z_PR).
assist_plan4(Z, A, Z_PR) :- F = req_deliv(REPORT), A_1 = ereport(_, _), A_2 = mreport(_, _), A = if(F, A_1, A_2), poss_if(F, A_1, A_2, Z), state_update_if(Z, F, A_1, A_2, Z_PR).

%GOAL:assist_plan([hasinput(PROBLEM), hasinput(LOCATION)], P, Z_IN_PR).
%GOAL:assist_plan([callcenterup, gpsactive(user1), systemactive(vehicle1), req_deliv(report1)], P, Z_IN_PR).
%GOAL: findall([P],assist_plan([callcenterup, gpsactive(user1), systemactive(vehicle1), req_deliv(report1)], P, Z_IN_PR), Results).