package wssl;

/**
* Models a simple constraint of the form -attribute- -operand- -value- 
* @author George
*/
public class Constraint {
	private String attr;
	private String op;
	private Object val;
	private String serviceName;
	private Boolean isGlobal;
	
	
	/**
	 * Creates a new Constraint object (global case)
	 * @param attr The attribute associated with the constraint
	 * @param op The operand associated with the constraint
	 * @param val The value associated with the constraint
	 */
	public Constraint(String attr, String op, float val){
		this.attr = new String(attr);
		this.op = new String(op);
		this.val = val;
		this.isGlobal = true;
		this.serviceName = new String("GLOBAL");
	}
	
	/**
	 * Creates a new Constraint object (local case)
	 * @param attr The attribute associated with the constraint
	 * @param op The operand associated with the constraint
	 * @param val The value associated with the constraint
	 * @param serviceName The service to which this local constraint refers
	 */
	public Constraint(String attr, String op, float val, String serviceName){
		this.attr = new String(attr);
		this.op = new String(op);
		this.val = val;
		this.isGlobal = false;
		this.serviceName = new String(serviceName);
	}	

	/**
	 * @return the serviceName
	 */
	public String getServiceName() {
		return serviceName;
	}

	/**
	 * @param serviceName the serviceName to set
	 */
	public void setServiceName(String serviceName) {
		this.serviceName = serviceName;
	}

	/**
	 * @return the isGlobal
	 */
	public Boolean getIsGlobal() {
		return isGlobal;
	}

	/**
	 * @param isGlobal the isGlobal to set
	 */
	public void setIsGlobal(Boolean isGlobal) {
		this.isGlobal = isGlobal;
	}

	/**
	 * @return the attr
	 */
	public String getAttr() {
		return attr;
	}

	/**
	 * @param attr the attr to set
	 */
	public void setAttr(String attr) {
		this.attr = attr;
	}

	/**
	 * @return the op
	 */
	public String getOp() {
		return op;
	}

	/**
	 * @param op the op to set
	 */
	public void setOp(String op) {
		this.op = op;
	}

	/**
	 * @return the val
	 */
	public Object getVal() {
		return val;
	}

	/**
	 * @param val the val to set
	 */
	public void setVal(float val) {
		this.val = val;
	}
	

}
