/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.evaluation;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.logging.Level;
import java.util.logging.Logger;
import wssl.validator.Validator;

/**
 *
 * @author George
 */
public class CreateEvalsFD2015 {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        URL def_location = Validator.class.getProtectionDomain().getCodeSource().getLocation();
        int[] size = {200,500,1000,2000,5000};
        String match = "E"; 
        int pos = 0;
        for(int i=0;i<size.length;i++){
            String url_w = "wssl/evaluation/fd2015-" + size[i] + match + ".pl";
            try {
                Path outpath = null;
                try {
                    outpath = Paths.get(new URI(def_location + url_w));
                } catch (URISyntaxException ex) {
                    Logger.getLogger(CreateEvalsFD2015.class.getName()).log(Level.SEVERE, null, ex);
                }
                try (OutputStream out = new BufferedOutputStream(Files.newOutputStream(outpath, StandardOpenOption.CREATE, StandardOpenOption.APPEND))) {
                    String writeOut = "";
                    for(int j=0;j<size[i];j++){
                        writeOut += "poss(spec" + (j+1) + ", Z) :- ";
                        for(int k=0;k<5;k++){
                        	if(pos==k){
                        		writeOut += "holds(key" + (j) + ", Z), ";
                        	}
                        	else{
                        		//writeOut += "holds(hasinput(io" + (j+1+k) + "), Z), holds(cond" + (j+1+k) + ", Z), ";
                        		writeOut += "holds(hasinput(io" + (k) + "), Z), holds(cond" + (k) + ", Z), ";
                        	}
                        }
                        //writeOut += "holds(key" + (j) + ", Z).\n";
                        writeOut = writeOut.substring(0, writeOut.length()-2);
                        writeOut += ".\n";
                    }
                    for(int j=0;j<size[i];j++){
                        writeOut += "state_update(Z, spec" + (j+1) + ", Z_PR) :- update(Z, [";
                        for(int k=0;k<5;k++){		
                    		//writeOut += "hasoutput(io" + (j+2+k) + "), cond" + (j+2+k) + ", ";
                    		writeOut += "hasoutput(io" + (k+2) + "), cond" + (k+2) + ", ";
                        }
                        //writeOut = writeOut.substring(0, writeOut.length()-2);
                        //writeOut += "key" + (j+1)+"], [";
                        for(int k=0;k<size[i];k++){		
                        	//writeOut += "hasinput(io" + (j+1+k) + "), cond" + (j+1+k) + ", ";
                        	writeOut += "hasinput(io" + (k) + "), cond" + (k) + ", ";
                        }
                        //writeOut = writeOut.substring(0, writeOut.length()-2);
                        writeOut += "key" + (j)+"], Z_PR).\n";                        
                    }
                    
                    /*writeOut += "init(X0) :- X0 = [hasinput(io1), cond1].\n";
                    writeOut += "init(Y0) :- Y0 = [hasinput(io500), cond500].\n";
                    writeOut += "init(Z0) :- Z0 = [hasinput(io1000), cond1000].\n";
                    writeOut += "match(T, Z, Z1) :- poss(T, Z), state_update(Z, T, Z1).";*/
                    byte data[] = writeOut.getBytes();
                    out.write(data, 0, data.length);
                    out.flush();
                }
            } catch (IOException ex) {
                    Logger.getLogger(CreateEvalsFD2015.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}