/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.evaluation;


import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import com.parctechnologies.eclipse.CompoundTerm;
import com.parctechnologies.eclipse.CompoundTermImpl;
import com.parctechnologies.eclipse.EclipseEngine;
import com.parctechnologies.eclipse.EclipseEngineOptions;
import com.parctechnologies.eclipse.EclipseException;
import com.parctechnologies.eclipse.EmbeddedEclipse;

import wssl.Constraint;
import wssl.planner.Planner;

/**
 * Realizes WSSL service composition, followed by abstract plan pruning and ranking
 * @author George
 */
public class ExtendedPR {
	
	public enum LOMode {BOOLEAN, UNORDERED, ORDERED, INCREASING, DECREASING}
	public static float WEIGHT_LEN = (float) 0.5;
	public static float WEIGHT_NUM = (float) 0.5;
	public static int tasksize = 100;
	public static int implsize = 50;
	public static float prune_percent = (float) 1;
			
    
    public static void main(String[] args) {
    	long startTime = System.currentTimeMillis();
    	long stopTime, elapsedTime=0;

            
        Constraint[] goals = new Constraint[5];	
        goals[0] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task1");
        goals[1] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task2");
        goals[2] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task3");
        goals[3] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task4");
        goals[4] = new Constraint("owlq:ExecutionTime", "lessThan", 30, "task5");
        
        String[] tasks = new String[]{"task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5","task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5","task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5", "task1", "task2", "task3", "task4", "task5"};
        //{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
        int[][] impls = new int[][]{{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30}};
        
        int[][] impls2 = new int[][]{{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30}};        
        
        /*int[][] impls = new int[][]{{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        							{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30}};*/
        
        /*int[][] impls = new int[][]{{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20},
				{20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20}};        
        
        int[][] impls2 = new int[][]{{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30}, 
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30}, 
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30},
        		{30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30}        		
        		};*/            

        PlanPruning(100, goals, tasks, impls, impls2);
        stopTime = System.currentTimeMillis();
        elapsedTime = stopTime - startTime;
        //CompoundTerm res;
        try {
            URL def_location = Planner.class.getProtectionDomain().getCodeSource().getLocation();            
            String url_w = "helpmeout3.pl";
            String url_f = "flux.pl";
            EclipseEngineOptions eclipseEngineOptions = new EclipseEngineOptions();
            EclipseEngine engine;
            eclipseEngineOptions.setUseQueues(false);
            engine = EmbeddedEclipse.getInstance(eclipseEngineOptions);
            engine.compile(new File(def_location.getFile() + url_f));
            engine.compile(new File(def_location.getFile() + url_w));
            String query = "findall([P],assist_plan([callcenterup, gpsactive(user1), systemactive(vehicle1), req_deliv(report1)], P, Z_IN_PR), Results).";
            //res = engine.rpc(query);
            engine.rpc(query);     
            ((EmbeddedEclipse) engine).destroy();
        } catch (EclipseException | IOException ex) {
            String reason = ex.toString();
            System.out.println(reason);
        }
        
        //PlanRanking(remain);
       // startTime = System.currentTimeMillis();
        
        //countLength(res);		
             
        
        //stopTime = System.currentTimeMillis();
        elapsedTime = elapsedTime + stopTime - startTime;
        System.out.println(elapsedTime);
            
            
    }
    

    public static int PlanPruning(int plans, Constraint[] goals, String[] tasks, int[][] impls, int[][] impls2){
    	int plans_ret = plans;
    	int pruned = 0;
    	for(int i=0;i<plans;i++){
    		outerloop:
    		for(int j=0;j<tasksize;j++){
    			for(int k=0;k<goals.length;k++){
    				if(goals[k].getServiceName().equals(tasks[j])){
    					int count=0;
    					for(int l=0;l<implsize;l++){
    						float val = (float) goals[k].getVal();
    						if(val>impls[j][l]){
    							count++;
    						}
    					}
    					//count=implsize;
    					if(count==implsize){
    						plans_ret--;
    						pruned=1;
    						if(plans_ret==plans-prune_percent*plans){
    							System.out.println("DDI");
    							impls = impls2;
    						}
    					}
    				}
    				if(pruned==1){
    					pruned=0;
    					break outerloop;
    				}
    			}
    		}
    	}
    	return plans_ret;
    	
    }
    
    /**
     * Recursively scans an ECLiPSe {@link CompoundTermImpl} to find all primitive action names
     * @param task the task to be scanned
     * @return an array list of action names
     */
    public static List<String> getActionNames(CompoundTermImpl task){
 	   List<String> ret_list = new ArrayList<String>();
 	   String taskFunctor = task.functor();
 	   if(taskFunctor.equals("and") || taskFunctor.equals("or") || taskFunctor.equals("xor") || taskFunctor.equals("if") || taskFunctor.equals("loop")){
 		   for(int n=0;n<task.arity();n++){
 			   CompoundTermImpl subtask = (CompoundTermImpl) task.arg(n+1);
 			   ret_list.addAll(getActionNames(subtask));
 		   }
 	   }
 	   else{
 		   ret_list.add(taskFunctor);
 	   }
 	   return ret_list;
    } 
    
    public static int countLength(CompoundTerm plans){
    	int ret_value=0;
        if(!(plans.functor().equals("findall") && plans.arity()==3)){
        	return 0;
        }
        else{
        	Object oj = plans.arg(3);
        	if(oj instanceof Collection){		
        		Collection<?> plans_ = (Collection<?>) oj;
                Iterator<?> plans_it = plans_.iterator();
                Object oj2 = plans_it.next();
                if(oj2 instanceof Collection){		
                	Collection<?> inter = (Collection<?>) oj2;
                		Iterator<?> inter_it = inter.iterator();
                		Object oj3 = inter_it.next();
                		Collection<?> tasks = (Collection<?>) oj3;
                		Iterator<?> tasks_it = tasks.iterator();
                		while(tasks_it.hasNext()){
                			CompoundTermImpl task = (CompoundTermImpl) tasks_it.next();
                			getActionNames(task);
                		}
                		//ret_value = tasks.size();
                	}
                }
        	}
        return ret_value;
    }
    
    /*public static void PlanRanking(int plans){
	   int actions=0;
	   int length=0;
	   for(int i=0;i<plans;i++){
		   for(int j=0;j<tasksize;j++){
			   actions++;
		   }
		   for(int j=0;j<tasksize;j++){
			   length++;
		   }		   
	   }
	   float rankval = WEIGHT_NUM * actions + WEIGHT_LEN * length;
      
    }*/
   
}
