/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.evaluation.plannew;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.logging.Level;
import java.util.logging.Logger;
import wssl.validator.Validator;

/**
 *
 * @author George
 */
public class CreateEvals {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        URL def_location = Validator.class.getProtectionDomain().getCodeSource().getLocation();
        int[] size = {5,10,50,100,200,500,1000};
        //int[] size = {5};
        for(int i=0;i<size.length;i++){
            String url_w = "wssl/evaluation/newseq" + size[i] + ".pl";
            try {
                Path outpath = null;
                try {
                    outpath = Paths.get(new URI(def_location + url_w));
                } catch (URISyntaxException ex) {
                    Logger.getLogger(CreateEvals.class.getName()).log(Level.SEVERE, null, ex);
                }
                try (OutputStream out = new BufferedOutputStream(Files.newOutputStream(outpath, StandardOpenOption.CREATE, StandardOpenOption.APPEND))) {
                    String writeOut = "";
                    for(int j=0;j<size[i];j++){
                        writeOut += "poss(spec" + (j+1) + ", Z) :- holds(hasinput(io" + (j+1) + "), Z), holds(cond" + (j+1) + ", Z).\n";
                    }
                    for(int j=0;j<size[i];j++){
                        writeOut += "state_update(Z, spec" + (j+1) + ", Z_PR) :- update(Z, [hasoutput(io" + (j+2) + "), cond" + (j+2) + "], [hasinput(io" + (j+1) + "), cond" + (j+1) + "], Z_PR).\n";
                    }  
                    writeOut += "planner(Z, [], Z) :- holds(cond" + size[i] + ", Z).\n";
                    writeOut += "planner(Z, [A|P], Z_PR) :- poss(A, Z), state_update(Z, A, Z1), planner(Z1, P, Z_PR)";
                    byte data[] = writeOut.getBytes();
                    out.write(data, 0, data.length);
                    out.flush();
                }
            } catch (IOException ex) {
                    Logger.getLogger(CreateEvals.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}