package wssl.matchmaker;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;

import wssl.planner.Planner;

//import com.parctechnologies.eclipse.CompoundTerm;
import com.parctechnologies.eclipse.EclipseEngine;
import com.parctechnologies.eclipse.EclipseEngineOptions;
import com.parctechnologies.eclipse.EclipseException;
import com.parctechnologies.eclipse.EmbeddedEclipse;

/**
 * Realizes WSSL service specification matchmaking (for WSSL files that have been translated to FLUX)
 * @author George
 */
public class Matchmaker {
	
	public static void main(String[] args) {
		long startTime = System.currentTimeMillis();
		/*Boolean[] success = new Boolean[]{true, true, true, true, true, true, true, true, true, true,
				true, true, true, true, true, true, true, true, true, true,
				true, true, true, true, true, true, true, true, true, true,
				true, true, true, true, true, true, true, true, true, true,
				true, true, true, true, true, true, true, true, true, true,
				true, true, true, true, true, true, true, true, true, true,
				true, true, true, true, true, true, true, true, true, true,
				true, true, true, true, true, true, true, true, true, true,
				true, true, true, true, true, true, true, true, true, true,
				true, true, true, true, true, true, true, true, true, true};*/

		for(int cc=0;cc<10;cc++){
			try {
	            URL def_location = Planner.class.getProtectionDomain().getCodeSource().getLocation();
	            //System.out.println(def_location.getFile());
	            //System.out.println(def_location);
	            //String url = "wssl/validator/samplewssl.xml";            
	            String url_source = "mm1.pl";
	            String url_target = "mm1-" + cc + ".pl";
	            //String url_target_alt = "mm1alt.pl";
	            //String url_mod = url_target.substring(0, url_target.length()-3) + "_mod.pl";
	            String url_f = "flux.pl";
	            String poss_goal = null;
	            String su_goal = null;
	            String pos_eff = null;
	            String neg_eff = null;
	            //DOMParser2 pr = new DOMParser2();
	            

	            //Path out = Paths.get(new URI(url_mod));
	            try {
	                //Files.copy(targ, out, StandardCopyOption.REPLACE_EXISTING);
	            	Path in = Paths.get(new URI(def_location + url_source));
	                Path targ = Paths.get(new URI(def_location + url_target));
	                //Path targ_alt = Paths.get(new URI(def_location + url_target_alt));
	                InputStream instr = new BufferedInputStream(Files.newInputStream(in, StandardOpenOption.READ));
	                BufferedReader reader = new BufferedReader(new InputStreamReader(instr));
	                //OutputStream outstr = new BufferedOutputStream(Files.newOutputStream(out, StandardOpenOption.APPEND));
	                String inp = null;
	                while((inp=reader.readLine())!=null){
	                	if(inp.startsWith("poss")){				//creating facts from source inputs and preconditions
	                		inp = inp.substring(inp.lastIndexOf(":-")+2);
	                		//String start_state = null;
	                		String fluents[] = inp.split("holds\\(");
	                		for(int i=1;i<fluents.length;i++){		//the first string is whatever's before the first holds
	                			/*if(i==0){
	                				start_state = fluents[i].substring(fluents[i].indexOf(" ")+1, fluents[i].lastIndexOf(")")-1);
	                			}*/
	                			fluents[i] = fluents[i].substring(0,fluents[i].indexOf(","));
	                			
	                		}
	                		poss_goal = "=[";
	                		for(int i=1;i<fluents.length;i++){
	                			poss_goal += fluents[i] + ", ";
	                		}
	                		poss_goal = poss_goal.substring(0,poss_goal.length()-2) + "]";
	                	}
	                	else if(inp.startsWith("state_update")){	//note that only simple state updates (one update/ramify clause) are supported
	                		inp = inp.substring(inp.lastIndexOf(":-")+2);
	                		pos_eff = inp.substring(inp.indexOf("[")+1, inp.indexOf("]"));
	                		/*String pos_arr[] = pos_eff.split(",");
	                		pos_eff = "[";
	                		for(int i=pos_arr.length-1;i>-1;i--){
	                			pos_eff += pos_arr[i] + ", ";
	                		}
	                		pos_eff = pos_eff.substring(0, pos_eff.length()-2) + "]";*/
	                		inp = inp.substring(inp.indexOf("]")+1);
	                		neg_eff = inp.substring(inp.indexOf("["), inp.indexOf("]")+1);
	                	}
	                	else{
	                		continue;
	                	}
	                }
	                //if(success[cc]==true){
	                	instr = new BufferedInputStream(Files.newInputStream(targ, StandardOpenOption.READ));
	                //}
	                //else{
	                //	instr = new BufferedInputStream(Files.newInputStream(targ_alt, StandardOpenOption.READ));
	                //}
	                reader = new BufferedReader(new InputStreamReader(instr));
	                String poss = null;
	                while((inp=reader.readLine())!=null){
	                	if(inp.startsWith("poss")){
	                		poss = inp.substring(0,inp.indexOf(":-")-1);
	                	}
	                	else if(inp.startsWith("state_update")){	//note that only simple state updates (one update/ramify clause) are supported
	                		String su = inp.substring(0,inp.indexOf(":-")-1);
	                		inp = inp.substring(inp.lastIndexOf(":-")+1);
	                		String start_state = inp.substring(inp.indexOf("(")+1, inp.indexOf(","));
	                		poss_goal = start_state + poss_goal + ", " + poss + ".";
	                		String end_state = inp.substring(inp.lastIndexOf(",")+1, inp.lastIndexOf(")"));
	                		//su_goal = su + ", " + start_state + "=" + neg_eff + ", " + end_state + "=" + pos_eff + ".";
	                		su_goal = start_state + "=" + neg_eff + ", " + end_state + "=" + pos_eff + ", " + su + ".";
	                	}
	                	else{
	                		continue;
	                	}
	                }                
	                	
	            } catch (IOException x) {
	                System.out.println(x.toString());
	            }

	                // Create some default Eclipse options
	            EclipseEngineOptions eclipseEngineOptions = new EclipseEngineOptions();
	            //eclipseEngineOptions.setEclipseDir(new File("/C:/Program Files (x86)/ECLiPSe 6.1/"));
	                // Object representing the Eclipse process
	            EclipseEngine engine;

	                // Connect the Eclipse's standard streams to the JVM's
	            eclipseEngineOptions.setUseQueues(false);

	                // Initialise Eclipse
	            engine = EmbeddedEclipse.getInstance(eclipseEngineOptions);
	            
	            //FromEclipseQueue stdout = engine.getEclipseStdout();  //manual stream parsing
	            //stdout.setListener(new OutputConsumer());
	            
	            engine.compile(new File(def_location.getFile() + url_f));
	            engine.compile(new File(def_location.getFile() + url_target));

	            //System.out.println("\nType an ECLiPSe query and press Enter: \n");
	            //BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
	            //String query = br.readLine();

	            //CompoundTerm res = engine.rpc(poss_goal);               
	            //res = engine.rpc(su_goal);
	            //System.out.println(su_goal);
	            engine.rpc(poss_goal);
	            engine.rpc(su_goal);

	            /*for(int i=0;i<pr.getSize();i++){
	                System.out.println(pr.getVariable(i)+"\n");
	            }*/

	                // Destroy the Eclipse process
	            ((EmbeddedEclipse) engine).destroy();
	        } catch (EclipseException | IOException | URISyntaxException ex) {
	            //String reason = ex.toString();
	            /*if(ex instanceof com.parctechnologies.eclipse.Fail){
	                System.out.println("Matchmaking has failed. The source specification is not equivalent to the target.");
	            }*/
	        	continue;
	            //Logger.getLogger(Validator.class.getName()).log(Level.SEVERE, null, ex);
	        }			
		}

        long stopTime = System.currentTimeMillis();
        long elapsedTime = stopTime - startTime;
        System.out.println(elapsedTime);
	}

}
