/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wssl.validator;
import com.parctechnologies.eclipse.*;
import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Collection;
import java.util.Iterator;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;
import wssl.parser.DOMParser2;
import wssl.parser.InvalidFormatException;

/*import java.io.BufferedOutputStream;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.StandardOpenOption;*/

/**
 * Simple application to validate a WSSL goal against a WSSL description
 * @author George Baryannis
 */


public class Validator {
    
    public static int varPos = 0;
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        //createSample(500);
        //long startTime = System.currentTimeMillis();
        try {
            URL def_location = Validator.class.getProtectionDomain().getCodeSource().getLocation();
            //System.out.println(def_location.getFile());
            //System.out.println(def_location);
            //String url = "wssl/validator/samplewssl.xml";
            String url = "wssl/test2.wssl";
            String url_s = "wssl/wssl2.xsd";
            String url_g = "wssl/goal2.wssl";
            String url_w = "wssl/wssl.pl";
            String url_f = "wssl/flux.pl";
            DOMParser2 pr = new DOMParser2();
            if(!pr.parse(new URL(def_location + url), new URL(def_location + url_s))){
                System.exit(-1);
            }
            Path out = Paths.get(new URI(def_location + url_w));
            pr.writePre(pr.getInp(), pr.getPre(), pr.getOutp().getLength(), out);
            pr.writePost(pr.getOutp(), pr.getPost(), out);
            //System.exit(1);
            //pr.writeCR(pr.getCR(), out);
            
            /*long stopTime = System.currentTimeMillis();
            long elapsedTime = stopTime - startTime;
            System.out.println(elapsedTime);

            //Getting the runtime reference from system
            Runtime runtime = Runtime.getRuntime();
            long memory = runtime.totalMemory() - runtime.freeMemory();
            System.out.println("Used Memory:" + memory +" bytes");
            System.out.println("Used Memory:" + (memory/1024L) +" kilobytes");
            runtime.gc();
            long memory_gc = runtime.totalMemory() - runtime.freeMemory();
            //Print used memory
            System.out.println("Used Memory:" + memory_gc +" bytes");
            System.out.println("Used Memory:" + (memory_gc/1024L) +" kilobytes");*/
                // Create some default Eclipse options
            EclipseEngineOptions eclipseEngineOptions = new EclipseEngineOptions();
            //eclipseEngineOptions.setEclipseDir(new File("/C:/Program Files (x86)/ECLiPSe 6.0/"));
                // Object representing the Eclipse process
            EclipseEngine engine;

                // Connect the Eclipse's standard streams to the JVM's
            eclipseEngineOptions.setUseQueues(false);

                // Initialise Eclipse
            engine = EmbeddedEclipse.getInstance(eclipseEngineOptions);
            
            //FromEclipseQueue stdout = engine.getEclipseStdout();  //manual stream parsing
            //stdout.setListener(new OutputConsumer());
            
            engine.compile(new File(def_location.getFile() + url_f));
            engine.compile(new File(def_location.getFile() + url_w));

            //System.out.print("Enter an ECLiPSe query and press Enter: ");
            //BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
            //String query = br.readLine();
            
            if(!pr.parse(new URL(def_location + url_g), new URL(def_location + url_s))){
                System.exit(-1);
            }
            
            /*String query = pr.writeGoals(pr.getGoals());      //feed goal in string form
            CompoundTerm res = engine.rpc(query);*/

            CompoundTerm[] goals = pr.writeGoalsCT(pr.getGoals());  //feed goal in CompoundTerm form
            System.out.println(goals[0].toString());
            
                      
            CompoundTerm res = engine.rpc(goals[0]);                //take only first goal for now                
            /*System.out.println(res.toString());
            for(int i=0;i<pr.getSize();i++){
                System.out.println(pr.getVariable(i)+"\n");
            }*/

            CompareCompoundTerms(pr, goals[0], res);
            System.out.println();
            
            
            
            /*CompoundTerm goal1 = (CompoundTerm) res.arg(1);
            CompoundTerm goal2 = (CompoundTerm) res.arg(2);
            LinkedList goal1_arg2 = (LinkedList) goal1.arg(2); //Second argument of poss (Z_IN)
            LinkedList goal2_arg3 = (LinkedList) goal2.arg(3); //Third argument of state_update (Z_IN_PR)
            String result = "Input state: ";
            for(int i=0;i<goal1_arg2.size();i++){
                CompoundTerm fluent = (CompoundTerm) goal1_arg2.get(i);
                if(i>0){
                    result += ", ";
                }
                result += fluent.functor() + "(...)"; 
            }
            result += "\nOutput state: ";
            for(int i=0;i<goal2_arg3.size();i++){
                CompoundTerm fluent = (CompoundTerm) goal2_arg3.get(i);
                if(i>0){
                    result += ", ";
                }
                result += fluent.functor() + "(...)";
            }*/

                // Destroy the Eclipse process
            ((EmbeddedEclipse) engine).destroy();
        } catch (URISyntaxException | InvalidFormatException | EclipseException | IOException | ParserConfigurationException | SAXException ex) {
            String reason = ex.toString();
            /*if(reason.startsWith("com.parc")){
                reason = "ECLiPSe syntax error";
            }*/
            System.out.println(reason);
            //Logger.getLogger(Validator.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
   
    
    /**
     * Compares {@link CompoundTerm} query (sent to Eclipse) with {@link CompoundTerm} result
     * (returned from ECLiPSe) in order to extract variable instantiations and
     * prints them to System.out. Note that the terms are not checked for being equivalent,
     * because such an equivalency is a direct result of how ECLiPSe operates.
     * @param parser The parser used to extract the goals and which contains the variable names
     * @param query The {@link CompoundTerm} object that contains the query
     * @param result The {@link CompoundTerm} object that is returned after executing query
     */
    public static void CompareCompoundTerms(DOMParser2 parser, CompoundTerm query, CompoundTerm result){
        for(int i=1;i<=query.arity();i++){
            if(query.arg(i)==null){         //variable instantiation
                if(result.arg(i)==null){    //the variable instantiation has already been printed
                    varPos++;
                    continue;
                }
                else{
                    System.out.print("\n"+parser.getVariable(varPos++)+ " = ");
                    printCompoundTerm(result.arg(i));    
                }
            }
            else{
                CompoundTerm query_ = (CompoundTerm) query.arg(i);
                CompoundTerm result_ = (CompoundTerm) result.arg(i);
                CompareCompoundTerms(parser, query_, result_);
            }
        }
    }
    
    /**
     * Parses a {@link Object} corresponding to a CompoundTerm and prints its contents
     * @param ct the {@link Object} to be printed
     */
    public static void printCompoundTerm(Object ct){
        if(ct==null){
            throw new IllegalArgumentException("CompoundTerm is null.");
        }
        else if(ct instanceof Atom){ // any collection is a list
            Atom at = (Atom) ct;
            System.out.print(at.functor());
        }
        else if(ct instanceof CompoundTerm){ // compound term
            CompoundTerm cterm = (CompoundTerm) ct;
            System.out.print(cterm.functor()+"(");
            for(int i=1;i<=cterm.arity();i++){
                if(i>1){
                    System.out.print(", ");
                }
                printCompoundTerm(cterm.arg(i));
            }
            System.out.print(")");
        }
        else if(ct instanceof Collection){ // any collection is a list
            System.out.print("[");
            Collection<?> cl = (Collection<?>) ct;
            Iterator<?> it = cl.iterator();
            while(it.hasNext()){
                printCompoundTerm(it.next());
                if(it.hasNext()){
                    System.out.print(", ");
                }
            }
            System.out.print("]");
        }
        else if(ct instanceof Integer){ // integer
            System.out.print(((Integer) ct).intValue());
        }
        else if(ct instanceof Long){ // long
            System.out.print(((Long) ct).longValue());
        }
        else if(ct instanceof Double){ // double
            System.out.print(((Double) ct).doubleValue());
        }
        else if(ct instanceof Float){ // float            
            System.out.print(((Float) ct).doubleValue());     // For floats, we convert a double, then write it
        }
        else if(ct instanceof String){ // string
            System.out.print((String) ct);
        }
        else{ // throw an IllegalArgument exception if the object is not of a recognised class
            throw(new IllegalArgumentException("CompoundTerm is of unrecognized class: "+ct.getClass().getName()));
        }
    }
    
    /*static class OutputConsumer implements QueueListener {
        FromEclipseQueue input_queue_stream = null;

        // Called when Eclipse flushes source
        @Override
        public void dataAvailable(Object source){
            if(input_queue_stream == null){
                input_queue_stream = (FromEclipseQueue) source;
            }
            System.out.println("HERE"+input_queue_stream);
        }
        
        // Required to implement QueueListener
        @Override
        public void dataRequest(Object source){
        }
    }*/
    
    /*public static void createSample(int size){        
        try {
            Path path = Paths.get(new URI(Validator.class.getProtectionDomain().getCodeSource().getLocation() + "wssl/validator/sample.xml"));
            try (OutputStream out = new BufferedOutputStream(Files.newOutputStream(path, StandardOpenOption.CREATE, StandardOpenOption.WRITE, StandardOpenOption.TRUNCATE_EXISTING))) {
                String writeOut = "<wssl\n" +
                "    xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n" +
                "    xsi:noNamespaceSchemaLocation=\"wssl.xsd\"\n" +
                "    variant=\"http://www.example.org/wssl#WSSL\">\n" +
                "    \n" +
                "    <service name=\"http://www.example.org/wssl#SampleService\">\n" +
                "        <grounding>\n" +
                "            http://www.example.org/wssl#SampleService.wsdl\n" +
                "        </grounding>\n" +
                "    </service>\n" +
                "    \n" +
                "    <input>\n" +
                "        <holds state=\"z\">\n" +
                "            <term type=\"HasInput\">\n" +
                "                <term type=\"xs:integer\">5</term>\n" +
                "            </term>\n" +
                "        </holds>\n" +
                "    </input>" +
                "    \n" +
                "    <output>\n" +
                "        <holds state=\"z\">\n" +
                "            <term type=\"HasOutput\">\n" +
                "                <term type=\"xs:integer\">10</term>\n" +
                "            </term>\n" +
                "        </holds>\n" +
                "    </output>\n";
                for(int i=0;i<size;i++){
                    writeOut += "    <precondition>\n" +
            "        <equivalent>\n" +
            "            <predicate name=\"poss\">\n" +
            "                <term type=\"http://www.example.org/wssl#Action\">\n" +
            "                    <term type=\"variable\">\n" +
            "                        <var name=\"x\"/>\n" +
            "                    </term>\n" +
            "                </term>\n" +
            "                <term type=\"variable\">\n" +
            "                    <var name=\"z\"/>\n" +
            "                </term>               \n" +
            "            </predicate>\n" +
            "            <holds state=\"z\">\n" +
            "                <term type=\"http://www.example.org/wssl#SampleFl" + i + "\">\n" +
            "                    <term type=\"xs:string\">SampleArg" + i + "</term>\n" +
            "                </term>\n" +
            "            </holds>\n" +
            "        </equivalent>\n" +
            "    </precondition>\n";
                }
                for(int i=0;i<size;i++){
                    writeOut += "    <postcondition>\n" +
            "        <implies>\n" +
            "            <predicate name=\"poss\">\n" +
            "                <term type=\"http://www.example.org/wssl#Action\">\n" +
            "                    <term type=\"variable\">\n" +
            "                        <var name=\"x\"/>\n" +
            "                    </term>\n" +
            "                </term>\n" +
            "                <term type=\"variable\">\n" +
            "                    <var name=\"z\"/>\n" +
            "                </term>               \n" +
            "            </predicate>\n" +
            "            <exists>\n" +
            "                <var name=\"y\"/>\n" +
            "                <equal>\n" +
            "                    <term type=\"State\">\n" +
            "                        <term type=\"Do\">\n" +
            "                            <term type=\"http://www.example.org/wssl#Action\">\n" +
            "                                <term type=\"variable\">\n" +
            "                                    <var name=\"x\"/>\n" +
            "                                </term>\n" +
            "                            </term>\n" +
            "                        </term>\n" +
            "                        <term type=\"variable\">\n" +
            "                                <var name=\"z\"/>\n" +
            "                        </term>\n" +
            "                    </term>\n" +
            "                    <minus>\n" +
            "                        <plus>\n" +
            "                            <term type=\"http://www.example.org/wssl#SampleFlP" + i + "\">\n" +
            "                                <term type=\"xs:string\">SampleArgP" + i + "</term>\n" +
            "                            </term>                            \n" +
            "                            <term type=\"State\">\n" +
            "                                <var name=\"z\"/>\n" +
            "                            </term>\n" +
            "                        </plus>\n" +
            "                        <term type=\"http://www.example.org/wssl#SampleFlM" + i + "\">\n" +
            "                            <term type=\"xs:string\">SampleArgM" + i + "</term>\n" +
            "                        </term>\n" +
            "                     </minus>\n" +
            "                </equal>\n" +
            "            </exists>\n" +
            "        </implies>\n" +
            "    </postcondition>\n";
                }
                writeOut += "</wssl>";
                byte data[] = writeOut.getBytes();
                out.write(data, 0, data.length);
                out.flush();
                out.close();
            }
        } catch (IOException | URISyntaxException ex) {
            Logger.getLogger(DOMParser.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }*/
}
